VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTreeView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'********************************************************************
'*             29.02.2004  (Team HomeWork)              *
'*                   e-mail: sne_pro@mail.ru                        *
'********************************************************************
'     ,   !               *
'********************************************************************

'   

Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

Private Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long

Private Declare Function SetFocusAPI Lib "user32.dll" Alias "SetFocus" (ByVal hwnd As Long) As Long
Private Declare Function UpdateWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function MoveWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As Any, ByVal bErase As Long) As Long

Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function GetAsyncKeyState Lib "user32.dll" (ByVal vKey As Long) As Integer
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Declare Function ImageList_Create Lib "comctl32.dll" (ByVal cx As Long, ByVal cy As Long, ByVal flags As Long, ByVal cInitial As Long, ByVal cGrow As Long) As Long
Private Declare Function ImageList_Destroy Lib "comctl32" (ByVal hImageList As Long) As Long
Private Declare Function ImageList_AddMasked Lib "comctl32.dll" (ByVal himl As Long, ByVal hbmImage As Long, ByVal crMask As Long) As Long
Private Declare Function ImageList_ReplaceIcon Lib "comctl32.dll" (ByVal himl As Long, ByVal i As Long, ByVal hIcon As Long) As Long

'   

Public Enum gbTreeViewStyle
    TVS_CHECKBOXES = &H100
    TVS_DISABLEDRAGDROP = &H10
    TVS_EDITLABELS = &H8
    TVS_FULLROWSELECT = &H1000
    TVS_HASBUTTONS = &H1
    TVS_HASLINES = &H2
    TVS_INFOTIP = &H800
    TVS_LINESATROOT = &H4
    TVS_NOHSCROLL = &H8000
    TVS_NONEVENHEIGHT = &H4000
    TVS_NOSCROLL = &H2000
    TVS_NOTOOLTIPS = &H80
    TVS_RTLREADING = &H40
    TVS_SHOWSELALWAYS = &H20
    TVS_SINGLEEXPAND = &H400
    TVS_TRACKSELECT = &H200
End Enum
Public Enum gbTreeViewRelatCnst
    TVI_ROOT = &HFFFF0000
    TVI_FIRST = &HFFFF0001
    TVI_LAST = &HFFFF0002
    TVI_SORT = &HFFFF0003
End Enum
Public Enum gbTreeViewItemState
    TVIS_BOLD = &H10
    TVIS_CUT = &H4
    TVIS_DROPHILITED = &H8
    TVIS_EXPANDED = &H20
    TVIS_EXPANDEDONCE = &H40
    TVIS_EXPANDPARTIAL = &H80
    TVIS_OVERLAYMASK = &HF00&
    TVIS_SELECTED = &H2
    TVIS_STATEIMAGEMASK = &HF000&
    TVIS_USERMASK = &HF000&
End Enum
Public Enum gbTreeViewItemExpand
    TVE_COLLAPSE = &H1
    TVE_EXPAND = &H2
    TVE_TOGGLE = &H3
    TVE_COLLAPSERESET = &H8000
    TVE_EXPANDPARTIAL = &H4000
End Enum
Public Enum gbTreeViewGetItem
    TVGN_ROOT = &H0
    TVGN_NEXT = &H1
    TVGN_PREVIOUS = &H2
    TVGN_PARENT = &H3
    TVGN_CARET = &H9
    TVGN_CHILD = &H4
    TVGN_FIRSTVISIBLE = &H5
    TVGN_NEXTVISIBLE = &H6
    TVGN_PREVIOUSVISIBLE = &H7
    TVGN_DROPHILITE = &H8
    TVGN_LASTVISIBLE = &HA
End Enum
Public Enum gbTVChangeSel
    TVC_UNKNOWN = &H0
    TVC_BYKEYBOARD = &H1
    TVC_BYMOUSE = &H2
End Enum
Public Enum gbTVRetValues
    TVNRET_DEFAULT = 0&
    TVNRET_SKIPOLD = 1&
    TVNRET_SKIPNEW = 2&
End Enum
Public Enum gbTVHScrollEnum
    SB_LINELEFT = 0
    SB_LINERIGHT = 1
    SB_PAGELEFT = 2
    SB_PAGERIGHT = 3
    SB_THUMBPOSITION = 4
    SB_THUMBTRACK = 5
    SB_LEFT = 6
    SB_RIGHT = 7
    SB_ENDSCROLL = 8
End Enum
Public Enum gbTVVScrollEnum
    SB_LINEUP = 0
    SB_LINEDOWN = 1
    SB_PAGEUP = 2
    SB_PAGEDOWN = 3
    SB_THUMBPOSITION = 4
    SB_THUMBTRACK = 5
    SB_TOP = 6
    SB_BOTTOM = 7
    SB_ENDSCROLL = 8
End Enum
Public Enum gbTVImgLstType
    TVSIL_NORMAL = 0
    TVSIL_STATE = 2
End Enum
Public Enum gbTVILColourDepth
    ILC_COLOR = &H0
    ILC_MASK = &H1
    ILC_COLOR4 = &H4
    ILC_COLOR8 = &H8
    ILC_COLOR16 = &H10
    ILC_COLOR24 = &H18
    ILC_COLOR32 = &H20
    ILC_PALETTE = &H800
End Enum
Public Enum gbTVBorderStyle
    WS_EX_STATICEDGE = &H20000
    WS_EX_CLIENTEDGE = &H200&
End Enum

'     

Private Type POINTAPI
    X               As Long
    Y               As Long
End Type
Private Type RECT
    Left            As Long
    Top             As Long
    Right           As Long
    Bottom          As Long
End Type

Private Type TVITEMEX
    Mask            As Long
    hItem           As Long
    state           As Long
    StateMask       As Long
    pszText         As String
    cchTextMax      As Long
    iImage          As Long
    iSelectedImage  As Long
    cChildren       As Long
    lParam          As Long
    iIntegral       As Long
End Type
Private Type TVINSERTSTRUCT
    hParent         As Long
    hInsertAfter    As Long
    Item            As TVITEMEX
End Type
Private Type TVHITTESTINFO
    pt              As POINTAPI
    flags           As Long
    hItem           As Long
End Type
Private Type gbTVItemTag
    hItem           As Long
    cKey            As String * 260
End Type
Private Type gbTVItemEnum
    hItem           As Long
    Enclosure       As Long
End Type

'   

Private Const TV_FIRST              As Long = &H1100

Private Const TVM_DELETEITEM        As Long = (TV_FIRST + 1)
Private Const TVM_EXPAND            As Long = (TV_FIRST + 2)
Private Const TVM_GETCOUNT          As Long = (TV_FIRST + 5)
Private Const TVM_SETBKCOLOR        As Long = (TV_FIRST + 29)
Private Const TVM_GETBKCOLOR        As Long = (TV_FIRST + 31)
Private Const TVM_SETTEXTCOLOR      As Long = (TV_FIRST + 30)
Private Const TVM_GETTEXTCOLOR      As Long = (TV_FIRST + 32)
Private Const TVM_GETITEM           As Long = (TV_FIRST + 12)
Private Const TVM_GETITEMHEIGHT     As Long = (TV_FIRST + 28)
Private Const TVM_GETNEXTITEM       As Long = (TV_FIRST + 10)
Private Const TVM_GETVISIBLECOUNT   As Long = (TV_FIRST + 16)
Private Const TVM_HITTEST           As Long = (TV_FIRST + 17)
Private Const TVM_INSERTITEM        As Long = (TV_FIRST + 0)
Private Const TVM_SELECTITEM        As Long = (TV_FIRST + 11)
Private Const TVM_SETINDENT         As Long = (TV_FIRST + 7)
Private Const TVM_SETITEM           As Long = (TV_FIRST + 13)
Private Const TVM_SETITEMHEIGHT     As Long = (TV_FIRST + 27)
Private Const TVM_SETTOOLTIPS       As Long = (TV_FIRST + 24)
Private Const TVM_GETTOOLTIPS       As Long = (TV_FIRST + 25)
Private Const TVM_GETIMAGELIST      As Long = (TV_FIRST + 8)
Private Const TVM_SETIMAGELIST      As Long = (TV_FIRST + 9)
Private Const TVM_EDITLABEL         As Long = (TV_FIRST + 14)

Private Const TVIF_TEXT             As Long = &H1
Private Const TVIF_IMAGE            As Long = &H2
Private Const TVIF_PARAM            As Long = &H4
Private Const TVIF_STATE            As Long = &H8
Private Const TVIF_HANDLE           As Long = &H10
Private Const TVIF_SELECTEDIMAGE    As Long = &H20
Private Const TVIF_CHILDREN         As Long = &H40

Private Const WS_VISIBLE            As Long = &H10000000
Private Const WS_CHILD              As Long = &H40000000

Private Const WM_NOTIFY             As Long = &H4E

Private Const SM_CXSMICON           As Long = 49
Private Const SM_CYSMICON           As Long = 50

Private Const cNull                 As Long = &H0

'   

Const AsmMain As String = "558BEC83C4FC8D45FC50FF7514FF7510FF750CFF75086800000000B800000000FFD08B45FCC9C21000"

Private OldCtl      As Long
Private OldPrnt     As Long

Private ASM_Ctl()   As Byte
Private ASM_Prnt()  As Byte

'   

Public Event Click()
Public Event RightClick(ByVal hItem As Long)
Public Event DblClick()
Public Event LostFocus()
Public Event GotFocus()

Public Event HScroll(ByVal cPos As Long, flag As gbTVHScrollEnum)
Public Event VScroll(ByVal cPos As Long, flag As gbTVVScrollEnum)

Public Event Expanded(ByVal hItem As Long)
Public Event ExpandSingle(ByVal hItemNew As Long, ByVal hItemOld As Long, ByRef RetValue As gbTVRetValues)
Public Event Expanding(ByVal hItem As Long, ByRef Cancel As Long)

Public Event SelChanged(ByVal hItemNew As Long, ByVal hItemOld, ByVal fAction As gbTVChangeSel)
Public Event SelChanging(ByVal hItem As Long, ByVal hItemOld, ByVal fAction As gbTVChangeSel, ByRef Cancel As Long)

Public Event InfoTip(ByVal hItem As Long, ByRef sText As String)
Public Event DeleteItem(ByVal hItemOld As Long, ByVal hItemNew As Long)

Public Event LabelEditStart(ByVal hItem As Long, ByRef CurrText As String, ByRef NoEdit As Long)
Public Event LabelEditEnd(ByVal hItem As Long, ByRef NewText As String, ByRef NoEdit As Long)

Public Event DragBegin(ByVal Button As MouseButtonConstants, ByVal hItem As Long, ByVal X As Long, ByVal Y As Long)
Public Event ManualChkCanged(ByVal hItem As Long)

Public Event MouseDown(ByVal Button As MouseButtonConstants, ByVal X As Long, ByVal Y As Long, ByVal Shift As Integer)
Public Event MouseMove(ByVal X As Long, ByVal Y As Long, ByVal Shift As Integer)
Public Event MouseUp(ByVal Button As MouseButtonConstants, ByVal X As Long, ByVal Y As Long, ByVal Shift As Integer)

Public Event KeyPress(KeyAscii As Long)
Public Event KeyDown(ByVal KeyCode As Long, ByVal Shift As Integer)
Public Event KeyUp(ByVal KeyCode As Long, ByVal Shift As Integer)

Private hTreeView   As Long     '  
Private hTVParent   As Long     '    
                                '   TreeView
Private ItemDataTag()  As gbTVItemTag
Private chkState As POINTAPI    '      ,     ...

    ' CallBack  
Public Function zTVCallBack(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case uMsg
        Case &H200 To &H209
            Dim Tmp As POINTAPI
            Call GetCursorPos(Tmp)
            Call ScreenToClient(hTreeView, Tmp)
    End Select
    Select Case uMsg                                                        '   
        Case &H201, &H204, &H207                                            ' MouseDwn
            chkState.X = Me.HitTest(Tmp.X, Tmp.Y)
            chkState.Y = MakeDWord(Abs(Me.ItemChecked(chkState.X)), 1&)

        Case &H202, &H205, &H208                                            ' MouseUp
            If chkState.X = Me.HitTest(Tmp.X, Tmp.Y) Then
                If CBool(LoWord(chkState.Y)) = Not Me.ItemChecked(chkState.X) And HiWord(chkState.Y) = 1& Then RaiseEvent ManualChkCanged(chkState.X)
            End If

        Case Is = &H100                                                     ' KeyDown
            If wParam = 32 Then
                chkState.X = Me.Item(0&, TVGN_CARET)
                chkState.Y = MakeDWord(Abs(Me.ItemChecked(chkState.X)), 2&)
            End If

        Case Is = &H101                                                     ' KeyUp
            If chkState.X = Me.Item(0, TVGN_CARET) Then
                If CBool(LoWord(chkState.Y)) = Not Me.ItemChecked(chkState.X) And HiWord(chkState.Y) = 2& Then RaiseEvent ManualChkCanged(chkState.X)
            End If
    End Select

    Select Case uMsg
        Case Is = &H114: RaiseEvent HScroll(HiWord(wParam), LoWord(wParam)) ' WM_HSCROLL
        Case Is = &H115: RaiseEvent VScroll(HiWord(wParam), LoWord(wParam)) ' WM_VSCROLL

        Case Is = &H100: RaiseEvent KeyDown(wParam, giGetShiftState)        ' WM_KEYDOWN
        Case Is = &H101: RaiseEvent KeyUp(wParam, giGetShiftState)          ' WM_KEYUP
        Case Is = &H102: RaiseEvent KeyPress(wParam)                        ' WM_CHAR

        Case Is = &H200: RaiseEvent MouseMove(Tmp.X, Tmp.Y, giGetShiftState)

        Case Is = &H201: RaiseEvent MouseDown(vbLeftButton, Tmp.X, Tmp.Y, giGetShiftState)
        Case Is = &H204: RaiseEvent MouseDown(vbRightButton, Tmp.X, Tmp.Y, giGetShiftState)
        Case Is = &H207: RaiseEvent MouseDown(vbMiddleButton, Tmp.X, Tmp.Y, giGetShiftState)

        Case Is = &H202: RaiseEvent MouseUp(vbLeftButton, Tmp.X, Tmp.Y, giGetShiftState)
        Case Is = &H205: RaiseEvent MouseUp(vbRightButton, Tmp.X, Tmp.Y, giGetShiftState)
        Case Is = &H208: RaiseEvent MouseUp(vbMiddleButton, Tmp.X, Tmp.Y, giGetShiftState)
    End Select

    zTVCallBack = CallWindowProc(OldCtl, hwnd, uMsg, wParam, lParam)
End Function

    ' CallBack   
Public Function zTVpCallBack(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim lng As Long, lng1 As Long, lng2 As Long, pt As POINTAPI, _
        tStr As String                                          '   NMHDR

    If uMsg = WM_NOTIFY Then
        Call CopyMemory(lng, ByVal lParam + 8, 4&)              '   NMHDR  code (lParam -   )

        Select Case lng
            Case Is = &HFFFE: RaiseEvent Click                  ' NM_CLICK
            Case Is = &HFFFD: RaiseEvent DblClick               ' NM_DBLCLICK
          ' Case Is = &HFFF4                                    ' NM_CUSTOMDRAW (  ,   )
            Case Is = &HFFF8: RaiseEvent LostFocus              ' NM_KILLFOCUS
            Case Is = &HFFFB
                Call GetCursorPos(pt)
                Call ScreenToClient(hTreeView, pt)
                RaiseEvent RightClick(Me.HitTest(pt.X, pt.Y))   ' NM_RCLICK

            Case Is = &HFFF9: RaiseEvent GotFocus               ' NM_SETFOCUS
            Case Is = &HFE66                                    ' TVN_BEGINLABELEDIT
                Call CopyMemory(lng1, ByVal lParam + 16&, 4&)   ' hItem (  )
                Call CopyMemory(lng2, ByVal lParam + 28&, 4&)   ' Text
                Call CopyMemory(pt.X, ByVal lParam + 32&, 4&)   ' TextLength
                
                If Not lng2 = cNull Then                        '    
                    tStr = String$(pt.X, 0&)
                    Call CopyMemory(ByVal tStr, ByVal lng2, pt.X) '    
                    tStr = Left$(tStr, InStr(vbNull, tStr, vbNullChar) - vbNull)
                End If
                RaiseEvent LabelEditStart(lng1, tStr, zTVpCallBack)
                
            Case Is = &HFE65                                    ' TVN_ENDLABELEDIT
                Call CopyMemory(lng1, ByVal lParam + 16&, 4&)   ' hItem (  )
                Call CopyMemory(lng2, ByVal lParam + 28&, 4&)   ' Text
                Call CopyMemory(pt.X, ByVal lParam + 32&, 4&)   ' TextLength
                
                If Not lng2 = cNull Then
                    tStr = String$(pt.X, 0&)                    '   TextLength
                    Call CopyMemory(ByVal tStr, ByVal lng2, pt.X) '    
                    tStr = Left$(tStr, InStr(vbNull, tStr, vbNullChar) - vbNull)
                End If
                RaiseEvent LabelEditEnd(lng1, tStr, zTVpCallBack)

                If Not lng2 = cNull Then                        '     
                    tStr = tStr & vbNullChar
                    Call CopyMemory(ByVal lng2, ByVal tStr, Len(tStr))
                End If
                zTVpCallBack = (zTVpCallBack = cNull)

            Case &HFE69, &HFE68                                 ' TVN_BEGINDRAG.   NMTREEVIEW (12 + 4 + 40 + 40 + 8)
                Call CopyMemory(lng1, ByVal lParam + 60&, 4&)
                Call CopyMemory(pt.X, ByVal lParam + 96&, 4&)
                Call CopyMemory(pt.Y, ByVal lParam + 100&, 4&)
                RaiseEvent DragBegin(&HFE6A - lng, lng1, pt.X, pt.Y)
            
            Case Is = &HFE67                                    ' TVN_DELETEITEM.   NMTREEVIEW (12 + 4 + 40 + 40 + 8)
                Call CopyMemory(lng1, ByVal lParam + 20&, 4&)
                Call CopyMemory(lng2, ByVal lParam + 60&, 4&)
                RaiseEvent DeleteItem(lng1, lng2)

            Case Is = &HFE63                                    ' TVN_GETINFOTIP
                Call CopyMemory(lng1, ByVal lParam + 20&, 4&)   ' hItem
                Call CopyMemory(lng2, ByVal lParam + 12&, 4&)   ' Text
                Call CopyMemory(pt.X, ByVal lParam + 16&, 4&)   ' TextLength

                If Not (pt.X = cNull Or lng2 = cNull) Then
                    tStr = String$(pt.X, 0&)                    '   TextLength
                    Call CopyMemory(ByVal tStr, ByVal lng2, pt.X) '    
                    tStr = Left$(tStr, InStr(vbNull, tStr, vbNullChar) - vbNull)
                End If
                RaiseEvent InfoTip(lng1, tStr)                  '     ;)
                If Not (pt.X = cNull Or lng2 = cNull) Then Call CopyMemory(ByVal lng2, ByVal tStr, pt.X)

            Case Is = &HFE6A                                    ' TVN_ITEMEXPANDED
                Call CopyMemory(lng1, ByVal lParam + 60&, 4&)
                RaiseEvent Expanded(lng1)

            Case Is = &HFE6B                                    ' TVN_ITEMEXPANDING
                Call CopyMemory(lng1, ByVal lParam + 60&, 4&)
                RaiseEvent Expanding(lng1, zTVpCallBack)

            Case Is = &HFE61                                    ' TVN_SINGLEEXPAND
                Call CopyMemory(lng2, ByVal lParam + 20&, 4&)   ' 
                Call CopyMemory(lng1, ByVal lParam + 60&, 4&)   ' 
                RaiseEvent ExpandSingle(lng1, lng2, zTVpCallBack)

            Case Is = &HFE6E                                    ' TVN_SELCHANGED
                Call CopyMemory(lng1, ByVal lParam + 12&, 4&)
                Call CopyMemory(pt.X, ByVal lParam + 20&, 4&)
                Call CopyMemory(pt.Y, ByVal lParam + 60&, 4&)
                RaiseEvent SelChanged(pt.Y, pt.X, lng1)

            Case Is = &HFE6F                                    ' TVN_SELCHANGING
                Call CopyMemory(lng1, ByVal lParam + 12&, 4&)
                Call CopyMemory(pt.X, ByVal lParam + 20&, 4&)
                Call CopyMemory(pt.Y, ByVal lParam + 60&, 4&)
                RaiseEvent SelChanging(pt.Y, pt.X, lng1, zTVpCallBack)

        End Select
        Exit Function
    End If

    zTVpCallBack = CallWindowProc(OldPrnt, hwnd, uMsg, wParam, lParam)
End Function

' 
'     
' 

Public Function Create(ByVal hParent As Long, _
                       ByVal dwStyle As gbTreeViewStyle, _
                       ByVal nLeft As Long, _
                       ByVal nTop As Long, _
                       ByVal nWidth As Long, _
                       ByVal nHeight As Long, _
              Optional ByVal Border As gbTVBorderStyle) As Long     '  ...

    Call InitCommonControls

    hTVParent = CreateWindowEx(cNull, "STATIC", "(c) Team HW (sne)", WS_VISIBLE Or WS_CHILD, nLeft, nTop, nWidth, nHeight, hParent, 0&, App.hInstance, ByVal 0&)
    hTreeView = CreateWindowEx(Border, "SysTreeView32", vbNullString, WS_VISIBLE Or WS_CHILD Or TVS_HASLINES Or dwStyle, 0&, 0&, nWidth, nHeight, hTVParent, cNull, App.hInstance, ByVal cNull)

    Call SendMessage(hTreeView, TVM_SETBKCOLOR, cNull, ByVal &HFFFF)    ' - 1 default
    Call SendMessage(hTreeView, TVM_SETTEXTCOLOR, cNull, ByVal &HFFFF)
    Call SendMessage(hTreeView, TVM_SETINDENT, &H10, ByVal cNull)
    Call SendMessage(hTreeView, TVM_SETITEMHEIGHT, &H10, ByVal cNull)

    Create = hTreeView

    Call StartSubclass(ASM_Ctl, hTreeView, OldCtl, cNull)           '   
    Call StartSubclass(ASM_Prnt, hTVParent, OldPrnt, vbNull)        '    
End Function

Public Sub Destroy()                                                '      ...
    If OldCtl Then Call StopSabclass(hTreeView, OldCtl):    OldCtl = cNull
    If OldPrnt Then Call StopSabclass(hTVParent, OldPrnt):  OldPrnt = cNull

    If Me.ImageList(TVSIL_NORMAL) Then Call ImageList_Destroy(Me.ImageList(TVSIL_NORMAL))
    If hTreeView Then Call DestroyWindow(hTreeView):  hTreeView = cNull
    If hTVParent Then Call DestroyWindow(hTVParent):  hTVParent = cNull
End Sub

'  ImageList 
                                                                    '   (  ,   )
Public Function ImageListCreate(Optional ByVal lColor As gbTVILColourDepth = ILC_COLOR24 Or ILC_MASK, _
                                Optional ByVal InitialImages As Long, _
                                Optional ByVal TotalImages As Long) As Long
    Call InitCommonControls
    ImageListCreate = ImageList_Create(GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), lColor, InitialImages, TotalImages)
End Function
                                                                    '  
Public Function ImageListAddMasked(ByVal hImage As Long, ByVal cMask As Long) As Long
    ImageListAddMasked = ImageList_AddMasked(Me.ImageList(TVSIL_NORMAL), hImage, cMask)
End Function
                                                                    '  
Public Function ImageListAddIcon(ByVal hIcon As Long) As Long
    ImageListAddIcon = ImageList_ReplaceIcon(Me.ImageList(TVSIL_NORMAL), &HFFFF, hIcon)
End Function

'  /ImageList 

Public Sub DeleteItem(ByVal hItem As Long)                          '  
    Call SendMessage(hTreeView, TVM_DELETEITEM, cNull, ByVal hItem)
End Sub
                                                                    '  
Public Function AddItem(Optional ByVal hRelativeItem As Variant = 0&, _
                        Optional ByVal tRelation As gbTreeViewRelatCnst = TVI_LAST, _
                        Optional ByVal sText As String = vbNullString, _
                        Optional ByVal sKey As String = vbNullString, _
                        Optional ByVal inImage As Long = &HFFFF, _
                        Optional ByVal inSelectedImage As Long = &HFFFF, _
                        Optional ByVal inBold As Boolean = False) As Long

    Dim TVIN As TVINSERTSTRUCT, hRel As Long

    Select Case TypeName(hRelativeItem)
        Case Is = "Long":   hRel = hRelativeItem
        Case Is = "String": hRel = FindByKey(CStr(hRelativeItem))
    End Select

    With TVIN
        .hParent = hRel

        With TVIN.Item
            .Mask = TVIF_TEXT Or TVIF_STATE Or TVIF_IMAGE Or TVIF_SELECTEDIMAGE
            .iImage = inImage
            .iSelectedImage = IIf(inSelectedImage = &HFFFF, inImage, inSelectedImage)

            .pszText = sText & vbNullChar
            .cchTextMax = Len(.pszText)

            .StateMask = TVIS_BOLD
            .state = IIf(inBold, TVIS_BOLD, cNull)
        End With
    
        If tRelation = TVI_ROOT Then
            .hParent = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_PARENT, ByVal hRel)
            .hInsertAfter = hRel
        Else
            .hInsertAfter = tRelation
        End If
    End With

    AddItem = SendMessage(hTreeView, TVM_INSERTITEM, cNull, TVIN)

    '   TreeView
    ReDim Preserve ItemDataTag(TagCount + vbNull)

    With ItemDataTag(UBound(ItemDataTag))
        .cKey = sKey
        .hItem = AddItem
    End With
End Function

'   

Public Property Get ItemChecked(ByVal Item As Long) As Boolean      ' 
    ItemChecked = Abs((GetItemState(Item, TVIS_STATEIMAGEMASK, TVIF_STATE).state \ &H1000) - vbNull)
End Property
Public Property Let ItemChecked(ByVal Item As Long, ByRef New_ItemChecked As Boolean)
    Dim TVI As TVITEMEX
    TVI = GetItemState(Item, TVIS_STATEIMAGEMASK, TVIF_STATE)

    TVI.state = IIf(New_ItemChecked, 2, 1) * &H1000
    TVI.StateMask = TVIS_STATEIMAGEMASK

    Call SetItemState(TVI, TVIF_STATE)
End Property
                                                                    '  
Public Property Let ItemExpanded(ByVal Item As Long, ByVal New_ItemExpanded As gbTreeViewItemExpand)
    Call SendMessage(hTreeView, TVM_EXPAND, New_ItemExpanded, ByVal Item)
End Property

Public Property Get ItemChild(ByVal Item As Long) As Long           '  child 
    ItemChild = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_CHILD, ByVal Item)
End Property

Public Property Let ItemSelected(ByVal hItem As Long)
    Call SendMessage(hTreeView, TVM_SELECTITEM, TVGN_CARET, ByVal hItem)
End Property

Public Property Let FirstVisible(ByVal New_ItemFirstVisible As Long)
    Call SendMessage(hTreeView, TVM_SELECTITEM, TVGN_FIRSTVISIBLE, ByVal New_ItemFirstVisible)
End Property

Public Property Get ItemHeight() As Long                            '  
    ItemHeight = SendMessage(hTreeView, TVM_GETITEMHEIGHT, cNull, ByVal cNull)
End Property
Public Property Let ItemHeight(ByVal inValue As Long)
    Call SendMessage(hTreeView, TVM_SETITEMHEIGHT, inValue, ByVal cNull)
End Property

Public Property Get ItemText(ByVal hItem As Long) As String         ' / 
    Const TVIF_TEXT As Long = &H1
    ItemText = GetItemState(hItem, TVIF_TEXT).pszText
End Property
Public Property Let ItemText(ByVal hItem As Long, ByRef sText As String)
    Dim TVI As TVITEMEX
    Const TVIF_TEXT As Long = &H1
    
    TVI = GetItemState(hItem, TVIF_TEXT)
    TVI.pszText = sText & vbNullChar
    TVI.cchTextMax = Len(TVI.pszText)

    Call SetItemState(TVI, TVIF_TEXT)
End Property
                                                                    '  ,  
Public Property Get Item(ByVal cItem As Long, ByVal flag As gbTreeViewGetItem) As Long
    Item = SendMessage(hTreeView, TVM_GETNEXTITEM, flag, ByVal cItem)
End Property
'
'Public Property Let ItemPlusMinus(ByVal Item As Long, ByVal New_ItemPlusMinus As Boolean)
'    Dim TVI As TVITEMEX
'    TVI = GetItemState(Item, , TVIF_CHILDREN)
'    TVI.cChildren = Abs(New_ItemPlusMinus)
'    Call SetItemState(TVI, TVIF_CHILDREN)
'End Property

Public Property Let BackColor(ByVal inColor As Long)                '  
    Call SendMessage(hTreeView, TVM_SETBKCOLOR, cNull, ByVal inColor)
End Property
Public Property Get BackColor() As Long
    BackColor = SendMessage(hTreeView, TVM_GETBKCOLOR, cNull, ByVal cNull)
End Property

Public Property Get ItemImage(ByVal hItem As Long) As Long
    ItemImage = GetItemState(hItem, TVIF_IMAGE).iImage
End Property
Public Property Let ItemImage(ByVal hItem As Long, ByVal nImage As Long)
    Dim TVI As TVITEMEX
    TVI.hItem = hItem
    TVI.iImage = nImage
    Call SetItemState(TVI, TVIF_IMAGE)
End Property

Public Property Get ItemImageSelected(ByVal hItem As Long) As Long
    ItemImageSelected = GetItemState(hItem, TVIF_IMAGE Or TVIF_SELECTEDIMAGE).iSelectedImage
End Property
Public Property Let ItemImageSelected(ByVal hItem As Long, ByVal nImage As Long)
    Dim TVI As TVITEMEX
    TVI.hItem = hItem
    TVI.iSelectedImage = nImage
    Call SetItemState(TVI, TVIF_SELECTEDIMAGE)
End Property

Public Property Get TextColor() As Long                             '  
    TextColor = SendMessage(hTreeView, TVM_GETTEXTCOLOR, cNull, cNull)
End Property
Public Property Let TextColor(ByVal inValue As Long)
    Call SendMessage(hTreeView, TVM_SETTEXTCOLOR, cNull, ByVal inValue)
End Property

Public Property Get ToolTips() As Long                              '   
    ToolTips = SendMessage(hTreeView, TVM_GETTOOLTIPS, cNull, cNull)
End Property
Public Property Let ToolTips(ByVal lpNewTolTips As Long)
    ToolTips = SendMessage(hTreeView, TVM_SETTOOLTIPS, lpNewTolTips, ByVal cNull)
End Property
                                                                    '   
Public Property Let ImageList(ByVal imType As gbTVImgLstType, ByVal hNewLst As Long)
    Call SendMessage(hTreeView, TVM_SETIMAGELIST, imType, ByVal hNewLst)
End Property
Public Property Get ImageList(ByVal imType As gbTVImgLstType) As Long
    ImageList = SendMessage(hTreeView, TVM_GETIMAGELIST, imType, ByVal cNull)
End Property

Public Property Let ItemData(ByVal hItem As Long, ByVal Value As Long)
    Dim TVI As TVITEMEX

    TVI.hItem = hItem
    TVI.lParam = Value
    Call SetItemState(TVI, TVIF_PARAM)
End Property
Public Property Get ItemData(ByVal hItem As Long) As Long
    ItemData = GetItemState(hItem, TVIF_PARAM).lParam
End Property

Public Property Get ItemHandle(Optional ByVal nIndex As Long = &HFFFF)
    If nIndex = &HFFFF Then nIndex = TagCount
    ItemHandle = ItemDataTag(nIndex).hItem
End Property

Public Sub StartEditLabel(ByVal hItem As Long)
    Call SendMessage(hTreeView, TVM_EDITLABEL, cNull, ByVal hItem)
End Sub
                                                                    '  - 
Public Function HitTest(ByVal X As Long, ByVal Y As Long) As Long
    Dim Ht As TVHITTESTINFO
    Ht.pt.X = X: Ht.pt.Y = Y

    Call SendMessage(hTreeView, TVM_HITTEST, 0, Ht)
    HitTest = Ht.hItem
End Function

Public Function Count(Optional ByVal fVisible As Boolean) As Long   ' - 
    Count = SendMessage(hTreeView, IIf(fVisible, TVM_GETVISIBLECOUNT, TVM_GETCOUNT), cNull, ByVal cNull)
End Function

Public Function EnumItems(ByRef sArray() As String, _
                 Optional ByVal hItem As Long, _
                 Optional ByVal Enclosure As Long) As Long        '   

    If hItem = cNull Then hItem = Me.Item(cNull, TVGN_ROOT)         '       
    Do While hItem                                                  '    - ROOT
        ReDim Preserve sArray(UboundS(sArray) + vbNull)             '  , ..     
                                                                    '     
        sArray(UBound(sArray)) = Me.ItemText(hItem) & _
        vbNullChar & Enclosure & _
        vbNullChar & hItem

        If Not Me.Item(hItem, TVGN_CHILD) = cNull Then              '    ,  ,  - !
            Call Me.EnumItems(sArray, Me.Item(hItem, TVGN_CHILD), Enclosure + vbNull)
        End If

        hItem = Me.Item(hItem, TVGN_NEXT)                           '  ,  . 
        DoEvents                                                    '   ,     ;)
    Loop

    EnumItems = UBound(sArray)                                      '  -  
End Function

Public Sub SetFocus()                                               '  
    Call SetFocusAPI(hTreeView)
End Sub
                                                                    ' / 
Public Sub Move(ByVal nLeft As Long, ByVal nTop As Long, _
       Optional ByVal nWidth As Long, Optional ByVal nHeight As Long)
    Dim hRect As RECT

    Call GetClientRect(hTVParent, hRect)

    If nWidth = cNull Then nWidth = hRect.Right
    If nHeight = cNull Then nHeight = hRect.Bottom

    Call MoveWindow(hTVParent, nLeft, nTop, nWidth, nHeight, vbNull)
    Call MoveWindow(hTreeView, nLeft, nTop, nWidth, nHeight, vbNull)
End Sub

Public Function hwnd() As Long                                      '  
    hwnd = hTreeView
End Function

Public Function Parent() As Long                                    '  
    Parent = hTVParent
End Function

Public Sub Redraw(Optional ByVal bState As Boolean = True)          ' 
    If bState Then
        Call SendMessage(hTreeView, &HB, vbNull, ByVal cNull)       ' WM_SETREDRAW
        Call InvalidateRect(hTreeView, cNull, vbNull)
        Call UpdateWindow(hTreeView)
    Else
        Call SendMessage(hTreeView, &HB, cNull, ByVal cNull)        ' WM_SETREDRAW
    End If
End Sub

'    
                                                                    ' /  
Private Function GetItemState(ByVal hItem As Long, _
                     Optional ByVal uMask As gbTreeViewItemState = cNull, _
                     Optional ByVal StateMask As Long = cNull) As TVITEMEX
    With GetItemState
        .Mask = uMask Or TVIF_HANDLE
        .StateMask = StateMask
        .hItem = hItem
        .pszText = String$(260, vbNullChar)
        .cchTextMax = 260

        Call SendMessage(hTreeView, TVM_GETITEM, cNull, GetItemState)

        .pszText = Left$(.pszText, InStr(vbNull, .pszText, vbNullChar, vbBinaryCompare) - vbNull)
        .cchTextMax = Len(.pszText)
    End With
End Function
Private Sub SetItemState(ByRef TVI As TVITEMEX, _
                         ByVal uMask As gbTreeViewItemState)

    TVI.Mask = uMask Or TVIF_HANDLE
    Call SendMessage(hTreeView, TVM_SETITEM, cNull, TVI)
End Sub
                                                                    '  
Private Function LoWord(DWord As Long) As Integer
    LoWord = IIf(DWord And &H8000&, DWord Or &HFFFF0000, DWord And &HFFFF&)
End Function
Private Function HiWord(DWord As Long) As Integer
    HiWord = (DWord And &HFFFF0000) \ &H10000
End Function
Private Function MakeDWord(LoWord As Integer, HiWord As Integer) As Long
    MakeDWord = (HiWord * &H10000) Or (LoWord And &HFFFF&)
End Function

Private Function giGetShiftState() As Integer                       '  ...
    giGetShiftState = (-vbShiftMask * gbKeyIsPressed(vbKeyShift))
    giGetShiftState = giGetShiftState Or (-vbAltMask * gbKeyIsPressed(vbKeyMenu))
    giGetShiftState = giGetShiftState Or (-vbCtrlMask * gbKeyIsPressed(vbKeyControl))
End Function

Private Function gbKeyIsPressed(ByVal nVirtKeyCode As KeyCodeConstants) As Boolean
    If (GetAsyncKeyState(nVirtKeyCode) And &H8000&) = &H8000& Then gbKeyIsPressed = True
End Function

Private Function UboundS(sArr() As String) As Long
    On Error Resume Next
    UboundS = &HFFFF
    UboundS = UBound(sArr)
End Function

'  ItemTag 

Private Function TagCount() As Long                                 ' -
    On Error Resume Next
    TagCount = &HFFFF
    TagCount = UBound(ItemDataTag)
End Function
Private Sub FastDelTag(ByVal nIndex As Long)                        '  
    Dim ub As Long: ub = TagCount

    If Not ub = 0 And Not ub = &HFFFF Then
        If Not ub = nIndex Then Call CopyMemory(ItemDataTag(nIndex), ItemDataTag(nIndex + vbNull), Len(ItemDataTag(nIndex)) * (ub - nIndex))
        ReDim Preserve ItemDataTag(ub - vbNull)
    Else
        Erase ItemDataTag
    End If
End Sub
                                    '   TreeView
Public Function FindByKey(ByRef sKey As String) As Long             '  hItem  sKey
    Dim fk As Long: FindByKey = &HFFFF

    For fk = 0 To TagCount
        If sKey = Left$(ItemDataTag(fk).cKey, Len(sKey)) Then FindByKey = ItemDataTag(fk).hItem: Exit For
    Next
End Function

'      VB 

Private Sub StartSubclass(ByRef ASM() As Byte, _
                          ByVal hwnd As Long, _
                          ByRef OldWndProc As Long, _
                 Optional ByVal ProcNumber As Long)                 '   . ASM (  ...)
    Dim lng As Long, tPtr As Long
    lng = Len(AsmMain) \ 2&

    ReDim ASM(cNull To lng - vbNull)
    For lng = cNull To lng - vbNull
        ASM(lng) = Val("&H" & Mid$(AsmMain, (lng) * 2& + vbNull, 2&))
    Next

    Call CopyMemory(tPtr, ByVal ObjPtr(Me), 4&)
    Call CopyMemory(lng, ByVal tPtr + &H1C + (4& * ProcNumber), 4&)

    Call CopyMemory(ASM(23), ObjPtr(Me), 4&)
    Call CopyMemory(ASM(28), lng, 4&)

    OldWndProc = SetWindowLong(hwnd, &HFFFC, VarPtr(ASM(0)))
End Sub

Private Sub StopSabclass(ByVal hwnd As Long, ByVal OldWndProc As Long)
    Call SetWindowLong(hwnd, &HFFFC, OldWndProc)
End Sub

Private Sub Class_Terminate()
    Call Me.Destroy
End Sub
